﻿/*----------------------------------------------*/
//  ParaFla Dan★Oniソース 
//  「スタート初期化」スクリプト
//                ver fd3.4.0 beta  2008/10/24
//				  ver fd3.8.8		2009/07/31
/*----------------------------------------------*/

/*----- 注意事項 ---------------------------------------------*/
// ・コメント以外の部分で、日本語は使用できません！
// 　(ParaFlaが強制終了するなどの問題が発生します)
// 
//　 何らかの事情で使いたい場合は
//　「最初の初期化」などのところで変数を作ってその変数を使用
//　 Ex.) _root.moji="処理しています";
/*-------------------------------------------------------------*/


stop();
_quality=_root.quality;

/*---- 譜面読み込みフラグ・結果関連初期化 ----*/
_root.gameovr		=false;		// ゲームオーバー解除
_root.view_result	=false;		// 表記倍速（最終的な倍速）

/*---- 得点・ライフ関係初期化 ----*/
var cunt=1;
_root.combo   =0;	_root.fcombo   =0;
_root.maxcombo=0;	_root.fmaxcombo=0;
_root.life		=startlife;

_root.iisc  =0;		_root.matsc =0;		_root.shasc = 0;
_root.syosc =0;		_root.uwasc =0;
_root.kitasc=0;		_root.iknsc =0;

/*----   速度の初期化   ----*/
_root.olds     = set_spi;
_root.bst_spi  = 1;
_root.apr_cnt  = (_root.stepArea.charAt(0)=="2" ? height_y/2+30 : height_y/2+15);

/*---- 判定関連の初期化 ----*/

// 現在判定する矢印番号の初期化
var arrcnt     = [0,0,0,0,0,0,0,0,0,0,0];
var farrcnt    = [0,0,0,0,0,0,0,0,0,0,0];
_root.local_arr= new Array();

_root.feff._y = _root.height_y-_root.eff._y;
this.change_judgement();

/*---- キーを押したときの設定 / 削除関数 ----*/
_root.keyPush = new Object();
Key.addListener(keyPush);

_root.keyPush.onKeyDown=function(){
	if(_root.set_spi!=0){
		var keyID = Key.getCode();
		switch(keyID){
			case _root.keyCtrl[0]:
				if(!_root.key_LE)	_root.judge_arrow(0);	break;
			case _root.keyCtrl[1]:	// 9keyではこのキーは代替として扱う
				if(!_root.key_LD)	_root.judge_arrow(1);	break;
			case _root.keyCtrl[2]:
				if(!_root.key_DO)	_root.judge_arrow(2);	break;
			case _root.keyCtrl[3]:
				if(!_root.key_SH)	_root.judge_arrow(3);	break;
			case _root.keyCtrl[4]:
				if(!_root.key_UP)	_root.judge_arrow(4);	break;
			case _root.keyCtrl[5]:	// 9keyではこのキーは代替として扱う
				if(!_root.key_RD)	_root.judge_arrow(5);	break;
			case _root.keyCtrl[6]:
				if(!_root.key_RI)	_root.judge_arrow(6);	break;
			case _root.keyCtrl[7]:
				if(!_root.key_L2)	_root.judge_arrow(7);	break;
			case _root.keyCtrl[8]:
				if(!_root.key_D2)	_root.judge_arrow(8);	break;
			case _root.keyCtrl[9]:
				if(!_root.key_U2)	_root.judge_arrow(9);	break;
			case _root.keyCtrl[10]:
				if(!_root.key_R2)	_root.judge_arrow(10);	break;
			case _root.keyCtrl[11]:	// 11keyの代替キー
				if(!_root.key_EX)	_root.judge_arrow(11);	break;
			case 46:			// タイトルバック(Delete)
				_root.del_all();
				_root.set_spi  =_root.olds;
          		_root.clear();
				if(Key.isDown(16)){
					_root.gameovr = true;
					_root.gotoAndPlay("goResult");
				}else{
					_root.gotoAndPlay("title");
				}
			break;
			case 8:				// 曲中リトライ(BackSpace)
				if(!_root.Key_RE){
					_root.del_all();
                	_root.clear();
					_root.set_spi  =_root.olds;
					_root.gotoAndPlay("play");
				}
			break;
		}
	}
};

//
// 画面上にある矢印の削除
function del_all(){
	_root.removeMovieClip();
	delete _root.onEnterFrame;
	Key.removeListener(keyPush);
	for(j=1;j<=300;j++){
		delete (main[local_arr[j]].onEnterFrame);
		main[local_arr[j]].removeMovieClip();
	}
	for(j=0;j<_root.key_limit;j++){
		main[hAr[j]+"_step"].removeMovieClip();
		main[hAr[j]+"_s"].removeMovieClip();
		main["f"+hAr[j]+"_s"].removeMovieClip();
	}
}

/*------  矢印・フリーズアロー設定  ------*/
//
//　・　Dan★Oniの核となる部分なので安易に弄らないこと！
//　・　矢印にモーションをつける場合はここではなく
//　　　基本的に [le_s][led_s]...などの部分で行うこと
//

//
// 矢印・フリーズアロー初期設定 (onLoad)
function make_arrow(j,num,header){

	cunt=(cunt>=300 ? 1 : ++cunt);
	var hd			 	= header+hAr[j];
	var newArr		 	= hd+"_s";
	var copnam		 	= newArr+_root[hd+"s"];
	main[newArr].duplicateMovieClip(copnam,cunt+200);
	var arr_obj		 	= main[copnam];
	
	arr_obj.setflg 		 = false;		            	// 判定を出したかどうかのフラグ
	arr_obj.count  		 = judgeY[num];	            	// ピッタリなタイミングまでのフレーム数
	arr_obj.bstcnt  	 = bstTime[num];	            // Sp.Motion
	arr_obj._alpha 		 = setAlpha[j];		            // 矢印の透明度
	arr_obj.moveY  		 = step_y+initY[num]*bst_spi;	// デフォルト換算のY座標
	arr_obj.spd    		 = bst_spi;		            	// 矢印のスピード（個別）
	arr_obj.rocate 		 = j;			            	// 矢印識別用変数
	arr_obj._y     		 = (revn[j]==1 ? arr_obj.moveY+stepDelta : height_y-arr_obj.moveY-stepDelta);
    if(_root.stepArea.charAt(0)=="2" && aprLabel[j]==0){
		arr_obj._y= (revn[j]==1 ? arr_obj._y+stepDelta2 : arr_obj._y-stepDelta2);
	}
	arr_obj.onEnterFrame	 = this[header+"mov_arrow"];
	this.local_arr[cunt]	 = arr_obj._name;

	return copnam;
}

//
// 矢印動作設定 (onEnterFrame)
function mov_arrow(){
	var j=this.rocate;

	if(_root.set_spi!=0){

		/*------ オプション設定 ------*/
		var c       = this.bstcnt;
		var mix_spd = (_root.set_spi + _root.mot_array[c])*this.spd;
		this.moveY -= mix_spd;
		this._y    -= _root.revn[j] * mix_spd;

		if(this.moveY>_root.apr_cnt){
		}else if(this.count>=-jdg_limit[2]){
			this._alpha+=_root.aprLabel[j]*(1.5*mix_spd);	// Appearance

		/*------ これより下は判定処理：分からない場合は弄らないこと ------*/

			// 
			// 対象の矢印がオートの場合は押したことにする
			if(_root.auto_arr[j]==1 && this.count==0){
				_root.auto_judge(j);
			}
		//
		// 枠外判定(ウワァン判定 / 矢印を消す)
		}else if(this.setflg==false){
			arrcnt[j]++;
			this.setflg=true;
			_root.uwa_j();
			this.removeMovieClip();
		}
		this.bstcnt--;
	}
	this.count--;
}
//
// フリーズアロー動作設定 (onEnterFrame)
function fmov_arrow(){
	var j=this.rocate;

   	if(_root.set_spi!=0){

		/*------ オプション設定 ------*/
		var c       = this.bstcnt;
		var mix_spd = (_root.set_spi + _root.mot_array[c])*this.spd;
		this.moveY -= mix_spd;
		this._y    -= _root.revn[j] * mix_spd;

		if(this.moveY>_root.apr_cnt){
		}else if(this.count>=-fjdg_limit[1]){
			this._alpha+=_root.aprLabel[j]*(1.5*mix_spd);	// Appearance

		/*------ これより下は判定処理：分からない場合は弄らないこと ------*/

			// 
			// 対象のフリーズアローがオートの場合は押したことにする
			if(_root.auto_arr[j]==1 && this.count==0){
				_root.fauto_judge(j);
			}
		//
		// 判定放棄(イクナイ確定)
		}else if(this.setflg==false){
			farrcnt[j]+=2;
			this.setflg=true;
			_root.ikn_j();
			this.gotoAndPlay("miss");
		}
		this.bstcnt--;
	}
	this.count--;
}
//
// オート判定 (オート以外のときは消去)
function auto_judge(j){
	var curArr = hAr[j]+"_s"+arrcnt[j];
	main[hAr[j]+"_step"].gotoAndPlay("hit");
	this.ii_j();

	main[curArr].removeMovieClip();
	main[curArr].setflg=true;
	arrcnt[j]++;
}
function fauto_judge(j){
	var fcurArr = "f"+hAr[j]+"_s"+farrcnt[j];
	main[fcurArr]._y    = main[hAr[j]+"_step"]._y;
	main[fcurArr]._alpha= 100;
	main[fcurArr].gotoAndPlay("hit");
	main[fcurArr].fa.gotoAndPlay("loop");

	farrcnt[j]+=2;
}